Subject: Re: [regext] WG LAST CALL: draft-ietf-regext-rfc7482bis

From: "Gould, James" <[email-masked]>
Date: Mon, 5 Oct 2020 15:41:04 +0000

>> The phrase 'registry-unique identifier' connotes a unique lookup key for entities, irrespective of their type. It puts the onus on a registry to ensure so. Does that not suffice?

There are cases where the entity lookup key is not unique, since the RDAP entity object can support multiple independent registry objects (contact and registrar).  The recommended text provides guidance for this use case:

  The <handle> parameter represents an entity (such as a contact,
  registrant, or registrar) identifier whose syntax is specific to the
  registration provider.  For example, for some DNRs, contact
  identifiers are specified in [RFC5730] and [RFC5733], and registrar
  identifiers are specified using the IANA Registrar ID assigned by
  ICANN.  The server SHOULD define a scheme for the <handle> parameter
  to differentiate between the supported entity object types (e.g.,
  contact and registrar), such as using different <handle> formats,
  using a <handle> precedence order, or a combination of formats and
  precedence order.

The question is whether the RDAP protocol should provide guidance with how to handle overlapping non-unique handles.  

-- 
 
JG

James Gould
Fellow Engineer
[email-masked] <applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com <http://verisigninc.com/>

On 10/5/20, 11:21 AM, "Jasdip Singh" <[email-masked]> wrote:

    Hi.
    
    Section 5.1 of 7483bis ( https://secure-web.cisco.com/1RB1WjHV1xP4ZSnvfV4N05YxMIUObjUDb1GSrtNRvknotxXZOR4r6KW5Mj3Gn99W8QZ13Y0iFQ04zJ7R_BKOXERI2tpouy1xS_xtTQKTLonQ90L6F_w_cgXMfIozB57eTNsab-6w2lvmRt77MpWM-K5Pu5LK-Fqk54dm9dQy3cLegMP53VV8WzcfvWEZRurzAyRPmNaz15FXIiRxZE7bmMEHJZ8KryIFe8Cn0m3YBCQOeaWD3mfU90e79jvRsN6fGjwj4e6YlktqOb45uycsLagfTLuJ9gZ6tH62OL5d8K_Y/https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-regext-rfc7483bis-01%23section-5.1 ) defines handle as:
    
      handle -- a string representing a registry-unique identifier of the entity
    
    The phrase 'registry-unique identifier' connotes a unique lookup key for entities, irrespective of their type. It puts the onus on a registry to ensure so. Does that not suffice?
    
    Jasdip
    
    On 10/5/20, 9:15 AM, "regext on behalf of Gould, James" <[email-masked] on behalf of jgould=[email-masked]> wrote:
    
        Scott,
        
        >> I'm still not comfortable with this. If we suggest that the server MUST or SHOULD do something to define a scheme, we leave open the issue of how a client discovers that scheme - and if we add a processing step to discover the scheme, we've changed the protocol from the client's 
        >> perspective. I still believe that this is an issue best addressed in an implementation profile document and not the protocol specification.
        
        I believe that providing guidance in the protocol to the real-world overlapping of entity handles (contact and registrar) as necessary.  The protocol would have explicit language on how to handle the case of overlapping entity handles.  A discovery mechanism is not needed, since we didn't have a need to create one based on the approach taken.  
        
        -- 
         
        JG

        James Gould
        Fellow Engineer
        [email-masked] <applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>
        
        703-948-3271
        12061 Bluemont Way
        Reston, VA 20190
        
        Verisign.com <http://secure-web.cisco.com/1bFp-HGXba90S-TZ720loQzOpgdlPHGtU1fQDrQ9fNgiBVvG2oS5BdIzJWl-ABbwRYIlChnZa-3-BARuMmAflz70zFR_bKIJwhdh0Nr1ZcSKNw7BWdMwC2ymrNNvJ7x52GuJAD5RE9q6FlpO0x4HgCZERFWRRmVLdn48hUgR6lqWjyR6qJwDpIZnLVA5YGBPSGHTynKhyv-_P3tY2ymxlwtAb56j-wQMA2mll8TNEFQ3XQ6-mkIFWQd_3j-DtwfmEgQ4K50V1RGMHkR3QiZL0pg/http%3A%2F%2Fverisigninc.com%2F>
        
        On 10/5/20, 9:00 AM, "regext on behalf of Hollenbeck, Scott" <[email-masked] on behalf of shollenbeck=[email-masked]> wrote:
        
            > -----Original Message-----
            > From: regext <[email-masked]> On Behalf Of Mario Loffredo
            > Sent: Saturday, October 3, 2020 3:18 AM
            > To: James Galvin <[email-masked]>; [email-masked]
            > Subject: [EXTERNAL] Re: [regext] WG LAST CALL: draft-ietf-regext-rfc7482bis
            >
            >
            > Il 02/10/2020 22:15, James Galvin ha scritto:
            > > The WGLC for this document was scheduled to end today.  While there is
            > > support to move the document forward there is one minor comment that
            > > has been raised during the last call.
            > >
            > > The chairs would like to hear from other working group members as to
            > > what to do with this comment.  Rather than close the last call and
            > > risk another last call, we are extending this last call for another
            > > week.  If we can come to a consensus as to how to proceed before the
            > > end of last call than the document can stay on track to be submitted
            > > to the IESG after the last call.
            > >
            > > The WG last call will end at close of business on Friday, 9 October 2020.
            > >
            > >
            > > Here are the comments as seen on the mailing list.  Please respond
            > > with your suggestions regarding these two comments.
            > >
            > >
            > > James Gould:
            > >
            > > Yes, lumping the registrar object with the contact object under a
            > > single RDAP entity object interface is the rub.  We solved the problem
            > > in the RDAP Profile, by supporting entity lookup by IANA ID (number)
            > > and registrar name (string) for the registrar objects, and by ROID
            > > (“((\w|_){1,80}-\w{1,8}") for the contact objects. Where there is
            > > overlap, which is registrar name (string) and ROID
            > > ((“((\w|_){1,80}-\w{1,8}") the contact takes precedence.  My
            > > recommendation is to provide guidance in the section 3.1.5 "Entity
            > > Path Segment Specification" for this real world case:
            > >
            > > The <handle> parameter represents an entity (such as a contact,
            > > registrant, or registrar) identifier whose syntax is specific to the
            > > registration provider.  For example, for some DNRs, contact
            > > identifiers are specified in [RFC5730] and [RFC5733], and registrar
            > > identifiers are specified using the IANA Registrar ID assigned by
            > > ICANN.  The server SHOULD define a scheme for the <handle> parameter
            > > to differentiate between the supported entity object types (e.g.,
            > > contact and registrar), such as using different <handle> formats,
            > > using a <handle> precedence order, or a combination of formats and
            > > precedence order.
            > >
            > > The SHOULD could be a MUST, but the point is to provide guidance to
            > > implementers of the protocol.
            > >
            > > Two responses have been offered:
            > >
            > > Jasdip Singh response:
            > >
            > > One thought is if it could be in the RDAP profile doc for the DNRs
            > > (https://secure-
            > web.cisco.com/1_AKsyXhtRLN9h4LEAG65owtJMhHrfLUp94HAp7iv6U5KRK_-
            > 2Mtzd56Rf4smGoyDJ4eiIqM3a4E73iWsnhGOX4YnFCyWF_xzCaslHxhJOxiqbH
            > hiSRwAiyk8mMkECJoYKSlQ1kmb4u3-
            > _sD2Be3SyrMHZApsS3iBtbY3MemXbSWSv4c6DFlq8sfMzGMjqy4PQekUbt9Lt
            > HcNRfwPHXhN9IFFpecud-xKW8luC4RDIz7jmjeFU9N11h-
            > lUPrhogswglEugCXCl95vnmjQ5lqytQ/https%3A%2F%2Fhttp://secure-web.cisco.com/1KzaMJBYCbHehlcyM7qgPzBHHaQvr1dOBGVjKZpsDWq867Y5KK33Xpj7gO1ijGMStZiT2-3TBK7ej3U5yYTxNbvIluknka0M48pQzXdUZwKvNgHeKhpieimICcERv8ytTgpOTh6oH_p_deFEo_xT15mJU5eJufBCSCEnu_AQMtR3VgaaURwLueY0Bw-Am4T5mb12dNiJHS_Uy6RpnXYUflqWBeQ0NCXczhOd7XkXyO62Kk1SHZ5UHdFFWrOFdBbuRuOkpX8FDJHhiWXx2xy2thQ/http%3A%2F%2Fwww.icann.org%2Fre
            > sources%2Fpages%2Frdap-operational-profile-2016-07-26-en).
            > > That way no need to update the spec.
            > >
            > > James Gould response:
            > >
            > > The RDAP Profile is dependent on the RFC, so I wouldn't create a
            > > circular dependency.  My recommendation is to take the lessons learned
            > > in implementing the RFC and provide guidance on how to handle it in
            > > the RFC directly.
            > >
            > >
            > The proposed update seems reasonable to me. However, we don't have to
            > make assumptions regarding how handle is generated by RDAP servers. In
            > my opinion, the document should simply give guidance to RDAP
            > implementers about how to disambiguate cases where overlap may occur.
            > Therefore, I would change the sentence as in the following:
            >
            > OLD
            >
            > The server SHOULD define a scheme
            > for the <handle> parameter to differentiate
            >
            > NEW
            >
            > Where overlap may occur, the server SHOULD define a scheme for the
            > <handle> parameter to differentiate
            
            I'm still not comfortable with this. If we suggest that the server MUST or SHOULD do something to define a scheme, we leave open the issue of how a client discovers that scheme - and if we add a processing step to discover the scheme, we've changed the protocol from the client's perspective. I still believe that this is an issue best addressed in an implementation profile document and not the protocol specification.
            
            Scott
            _______________________________________________
            regext mailing list
            [email-masked]
            https://secure-web.cisco.com/14qQ5GBAbqizg1W93npsiyV-qaIPAEr0IPtYJq1e7X-_7EoaNxVfB1TEiGzncUFjJiWvcnx6HykFwrZ-ABrD6xiCsFOMEGvVa2nDcW_IEtcp3Kp7hIrt7QPfU1p8toWJrW6Cam0kzs62ESNznCXJSwbu2i9LvV_B2lJ_5iFZL_W3yetKjwXg0uiEC8RQ26Ce90KoEXMuk-nZ5uY-UUHWe1MXXF9N0PIwrFts920hzq-qzWa1SHCEGSw3o0Odax04AFTW15t-zXQUXQWTY0UPnWd5ve9mRKR1zu3ao84TP6yA/https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fregext

        _______________________________________________
        regext mailing list
        [email-masked]
        https://secure-web.cisco.com/1_vHElpaUxk73mNxduCQugGlhT7YA0zpB1lFQlYCz2-KemyeQkHh9WyivFL5YIQPLNxfxOuYG9eCGm1FLypFLgXbMKYnXBKrf9f-t-KI_I8orT16HiTxOjpo5VrqRvzRn0Cj4ShQni2QAudK0ZUGRzZO2jteaxZBzJh9t-PY3m6nph0DOr1Pa-WSeg61hD9RmeHTTk8glBkviu3gz-Ow1jH1p28EqYCGiyBIKkW_qKgy7X_gDPySCkxWObGmQUnZdrk4doKSZnWX4VKFU2miBngkejzBugO_MzQ7TgvVBWkE/https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fregext

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Mon, 5 Oct 2020 16:03:40 +0000

> From: Gould, James <[email-masked]>
> Sent: Monday, October 5, 2020 11:41 AM
> To: [email-masked]; Hollenbeck, Scott <[email-masked]>;
> [email-masked]; [email-masked]; [email-masked]
> Subject: Re: [EXTERNAL] Re: [regext] WG LAST CALL: draft-ietf-regext-
> rfc7482bis
>
> >> The phrase 'registry-unique identifier' connotes a unique lookup key for
> entities, irrespective of their type. It puts the onus on a registry to ensure so.
> Does that not suffice?
>
> There are cases where the entity lookup key is not unique, since the RDAP
> entity object can support multiple independent registry objects (contact and
> registrar).  The recommended text provides guidance for this use case:
>
> The question is whether the RDAP protocol should provide guidance with
> how to handle overlapping non-unique handles.

I don't think it should. A Jasdip pointed out, the definition of a handle notes that they're supposed to be registry-unique.

Scott

---

From: Tom Harrison <[email-masked]>
Date: Wed, 7 Oct 2020 11:17:18 +1000

On Mon, Oct 05, 2020 at 04:03:40PM +0000, Hollenbeck, Scott wrote:
>>> The phrase 'registry-unique identifier' connotes a unique lookup
>>> key for entities, irrespective of their type. It puts the onus on
>>> a registry to ensure so.  Does that not suffice?
>> 
>> There are cases where the entity lookup key is not unique, since
>> the RDAP entity object can support multiple independent registry
>> objects (contact and registrar).  The recommended text provides
>> guidance for this use case:
>> 
> I don't think it should. A Jasdip pointed out, the definition of a
> handle notes that they're supposed to be registry-unique.

I agree with Scott and Jasdip on this point.

-Tom

---

From: "Thomas Corte (TANGO support)" <[email-masked]>
Date: Wed, 7 Oct 2020 10:46:52 +0200

Hello,

> I agree with Scott and Jasdip on this point.

I think it's problematic to have a standard like this (which will
eventually have to be implemented by all ICANN-regulated registries)
impose such a requirement (unique handles across all object types) out of
the blue when there are already hundreds of databases out there that were
not build with this assumption in mind.

Sure, a migration of non-unique handles is possible, and we did that when
ICANN demanded a specific ROID prefix per TLD, but that was a minor
change as the ROID isn't really used for operationally addressing
anything. Renaming contact IDs and/or registrar IDs would have more of an
impact, as it would also require all registrars to update their own
databases/configurations as well to reflect the new handles.

If "using a <handle> precedence order" means that a server can choose to
e.h. just deliver the contact when there's a registrar with the same
handle, that's an acceptably lenient interpretation. Otherwise, no
assumption about the uniqueness of entity handles should be made long
after the fact.

Best regards,

Thomas

-- 
TANGO REGISTRY SERVICES®
Knipp Medien und Kommunikation GmbH                    Thomas Corte
Technologiepark                             Phone: +49 231 9703-222
Martin-Schmeisser-Weg 9                       Fax: +49 231 9703-200
D-44227 Dortmund                      E-Mail: [email-masked]
Germany

---

From: Tom Harrison <[email-masked]>
Date: Wed, 7 Oct 2020 21:18:02 +1000

On Wed, Oct 07, 2020 at 10:46:52AM +0200, Thomas Corte (TANGO support) wrote:
>>>> The question is whether the RDAP protocol should provide guidance
>>>> with how to handle overlapping non-unique handles.
>>> 
> impose such a requirement (unique handles across all object types)
> out of the blue when there are already hundreds of databases out
> there that were not build with this assumption in mind.

Entity identifiers aren't RDAP 'entry points', though, in that there
are no guarantees that you can take an identifier from some other
context and construct a usable query like
'https://rdap.example.net/entity/$identifier' (putting RFC 8521 object
tags to one side), so it's not clear that it actually imposes this
requirement.  For example, it's open to an implementor to prefix their
existing identifiers with strings describing the underlying object
types, in order to construct unique entity handles.

-Tom